'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _lodash = require('lodash');

var DEFAULT_DATA_KEY = 'dynamicProps';

exports.default = function () {
  var DATA_KEY = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_DATA_KEY;
  return {
    created: function created() {
      this.dynamicPropsInitilize();
    },

    watch: {
      $props: {
        handler: function handler(props) {
          this[DATA_KEY] = _extends({}, props);
        },

        deep: true
      }
    },
    methods: {
      dynamicPropsInitilize: function dynamicPropsInitilize() {
        var data = this.$data;
        var isDup = false;

        (0, _lodash.forEach)(data, function (value, index) {
          if (index === DATA_KEY) {
            isDup = true;
            return false;
          }
        });

        if (!isDup) {
          this[DATA_KEY] = _extends({}, this.$props);
        } else {
          throw new Error('dynamicProps data key: ' + DATA_KEY + ' has been taken.');
        }
      }
    }
  };
};